diff -ur debootstrap-1.0.10/functions debootstrap-1.0.10.new/functions
--- debootstrap-1.0.10/functions	2008-12-27 00:50:04.810414076 +0000
+++ debootstrap-1.0.10.new/functions	2008-12-27 00:50:24.834985012 +0000
@@ -226,6 +226,10 @@
 		DOWNLOAD_INDICES=download_main_indices
 		DOWNLOAD_DEBS=download_main
 		;;
+	    flat)
+		DOWNLOAD_INDICES=download_flat_indices
+		DOWNLOAD_DEBS=download_main
+		;;
 	    *)
 		error 1 BADMIRROR "unknown mirror style"
 		;;
@@ -674,6 +678,28 @@
 	progress 100 100 DOWNMAINPKGS "Downloading Packages file"
 }
 
+download_flat_indices () {
+	local m1="${MIRRORS%% *}"
+	progress 0 100 DOWNMAINPKGS "Downloading Packages file"
+	progress_next 100
+	COMPONENTS=main
+	export COMPONENTS
+	for m in $MIRRORS; do
+	    for c in $COMPONENTS; do
+	    	local m_path="Packages"
+		local path="dists/$SUITE/$c/binary-$ARCH/Packages"
+	    	local pkgdest="$TARGET/$($DLDEST pkg "$SUITE" "$c" "$ARCH" "$m" "$path")"
+	    	if [ -x /bin/gunzip ] && get "$m/${m_path}.gz" "${pkgdest}.gz"; then
+			rm -f "$pkgdest"
+			gunzip "$pkgdest.gz"
+	    	elif get "$m/$m_path" "$pkgdest"; then
+			true
+		fi
+	    done
+	done
+	progress 100 100 DOWNMAINPKGS "Downloading Packages file"
+}
+
 download_main () {
 	local m1="${MIRRORS%% *}"
 
